/** @file options.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.6
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef OPTIONS_H
#define OPTIONS_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef OPTIONS_PACKAGE
/** @brief the program name (used for printing errors) */
#define OPTIONS_PACKAGE "svgx"
#endif

#ifndef OPTIONS_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define OPTIONS_PACKAGE_NAME "svgx"
#endif

#ifndef OPTIONS_VERSION
/** @brief the program version */
#define OPTIONS_VERSION VERSION
#endif

/** @brief Where the command line options are stored */
struct gengetopt_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int all_flag;	/**< @brief convert all gradients (default=off).  */
  const char *all_help; /**< @brief convert all gradients help description.  */
  char * background_arg;	/**< @brief background colour (cpt) (default='0/0/0').  */
  char * background_orig;	/**< @brief background colour (cpt) original value given at command line.  */
  const char *background_help; /**< @brief background colour (cpt) help description.  */
  char * backtrace_file_arg;	/**< @brief write backtrace to file.  */
  char * backtrace_file_orig;	/**< @brief write backtrace to file original value given at command line.  */
  const char *backtrace_file_help; /**< @brief write backtrace to file help description.  */
  char * backtrace_format_arg;	/**< @brief backtrace format.  */
  char * backtrace_format_orig;	/**< @brief backtrace format original value given at command line.  */
  const char *backtrace_format_help; /**< @brief backtrace format help description.  */
  char * foreground_arg;	/**< @brief foreground colour (cpt) (default='255/255/255').  */
  char * foreground_orig;	/**< @brief foreground colour (cpt) original value given at command line.  */
  const char *foreground_help; /**< @brief foreground colour (cpt) help description.  */
  char * geometry_arg;	/**< @brief image size (png, svg) (default='340x36').  */
  char * geometry_orig;	/**< @brief image size (png, svg) original value given at command line.  */
  const char *geometry_help; /**< @brief image size (png, svg) help description.  */
  char * nan_arg;	/**< @brief nan colour (cpt) (default='255/0/0').  */
  char * nan_orig;	/**< @brief nan colour (cpt) original value given at command line.  */
  const char *nan_help; /**< @brief nan colour (cpt) help description.  */
  int list_flag;	/**< @brief list gradients in file (default=off).  */
  const char *list_help; /**< @brief list gradients in file help description.  */
  char * select_arg;	/**< @brief convert gradient with specifed name.  */
  char * select_orig;	/**< @brief convert gradient with specifed name original value given at command line.  */
  const char *select_help; /**< @brief convert gradient with specifed name help description.  */
  int strict_flag;	/**< @brief obey format limits on output (default=off).  */
  const char *strict_help; /**< @brief obey format limits on output help description.  */
  char * output_arg;	/**< @brief output filename (not with -a).  */
  char * output_orig;	/**< @brief output filename (not with -a) original value given at command line.  */
  const char *output_help; /**< @brief output filename (not with -a) help description.  */
  int preview_flag;	/**< @brief include preview (svg) (default=off).  */
  const char *preview_help; /**< @brief include preview (svg) help description.  */
  char * type_arg;	/**< @brief output format (see manual).  */
  char * type_orig;	/**< @brief output format (see manual) original value given at command line.  */
  const char *type_help; /**< @brief output format (see manual) help description.  */
  char * transparency_arg;	/**< @brief replace transparency by colour (default='255/255/255').  */
  char * transparency_orig;	/**< @brief replace transparency by colour original value given at command line.  */
  const char *transparency_help; /**< @brief replace transparency by colour help description.  */
  int verbose_flag;	/**< @brief verbose operation (default=off).  */
  const char *verbose_help; /**< @brief verbose operation help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int all_given ;	/**< @brief Whether all was given.  */
  unsigned int background_given ;	/**< @brief Whether background was given.  */
  unsigned int backtrace_file_given ;	/**< @brief Whether backtrace-file was given.  */
  unsigned int backtrace_format_given ;	/**< @brief Whether backtrace-format was given.  */
  unsigned int foreground_given ;	/**< @brief Whether foreground was given.  */
  unsigned int geometry_given ;	/**< @brief Whether geometry was given.  */
  unsigned int nan_given ;	/**< @brief Whether nan was given.  */
  unsigned int list_given ;	/**< @brief Whether list was given.  */
  unsigned int select_given ;	/**< @brief Whether select was given.  */
  unsigned int strict_given ;	/**< @brief Whether strict was given.  */
  unsigned int output_given ;	/**< @brief Whether output was given.  */
  unsigned int preview_given ;	/**< @brief Whether preview was given.  */
  unsigned int type_given ;	/**< @brief Whether type was given.  */
  unsigned int transparency_given ;	/**< @brief Whether transparency was given.  */
  unsigned int verbose_given ;	/**< @brief Whether verbose was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct options_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure gengetopt_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure gengetopt_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *gengetopt_args_info_purpose;
/** @brief the usage string of the program */
extern const char *gengetopt_args_info_usage;
/** @brief the description string of the program */
extern const char *gengetopt_args_info_description;
/** @brief all the lines making the help output */
extern const char *gengetopt_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int options (int argc, char **argv,
  struct gengetopt_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use options_ext() instead
 */
int options2 (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int options_ext (int argc, char **argv,
  struct gengetopt_args_info *args_info,
  struct options_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int options_dump(FILE *outfile,
  struct gengetopt_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int options_file_save(const char *filename,
  struct gengetopt_args_info *args_info);

/**
 * Print the help
 */
void options_print_help(void);
/**
 * Print the version
 */
void options_print_version(void);

/**
 * Initializes all the fields a options_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void options_params_init(struct options_params *params);

/**
 * Allocates dynamically a options_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized options_params structure
 */
struct options_params *options_params_create(void);

/**
 * Initializes the passed gengetopt_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void options_init (struct gengetopt_args_info *args_info);
/**
 * Deallocates the string fields of the gengetopt_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void options_free (struct gengetopt_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int options_required (struct gengetopt_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* OPTIONS_H */
